package com.friday.custody.service.basicService.impl;

import com.friday.custody.entity.DataDictionarySellerStatusDetailsEntity;
import com.friday.custody.enums.DataDictionaryTypeEnum;
import com.friday.custody.service.basicService.DataDictionarySellerStatusDetailsService;
import com.friday.custody.service.logicService.DataDictionaryBasicService;
import com.friday.custody.utils.R;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.friday.custody.utils.PageUtils;
import com.friday.custody.utils.Query;

import com.friday.custody.dao.DataDictionarySellerStatusDao;
import com.friday.custody.entity.DataDictionarySellerStatusEntity;
import com.friday.custody.service.basicService.DataDictionarySellerStatusService;


@Service("dataDictionarySellerStatusService")
public class DataDictionarySellerStatusServiceImpl extends ServiceImpl<DataDictionarySellerStatusDao, DataDictionarySellerStatusEntity>
        implements DataDictionarySellerStatusService, DataDictionaryBasicService {

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<DataDictionarySellerStatusEntity> page = this.page(
                new Query<DataDictionarySellerStatusEntity>().getPage(params),
                new QueryWrapper<DataDictionarySellerStatusEntity>()
        );

        return new PageUtils(page);
    }

    @Autowired
    private DataDictionarySellerStatusDetailsService detailsService;
    @Override
    public Map<String, String> queryWithDetail(String trustNo) {
        HashMap<String, String> result = new HashMap<>();
        List<DataDictionarySellerStatusEntity> allDatas = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(allDatas)) {
            List<DataDictionarySellerStatusDetailsEntity> detailsEntities = detailsService.selectVByTrustNo(trustNo);
            if (!CollectionUtils.isEmpty(detailsEntities)) {
                Map<String, Integer> originValueKeyMap = detailsEntities.stream().collect(Collectors.toMap(DataDictionarySellerStatusDetailsEntity::getOriginValue, DataDictionarySellerStatusDetailsEntity::getDicId));
                Map<Integer, String> idKeyMap = allDatas.stream().collect(Collectors.toMap(DataDictionarySellerStatusEntity::getId, DataDictionarySellerStatusEntity::getKeyStr));
                originValueKeyMap.forEach((originValue, id) -> {
                    result.put(originValue, idKeyMap.get(id));
                });
            } else {
                log.error("DataDictionarySellerStatusDetailsEntity 查询失败！");
            }
        } else {
            log.error("DataDictionarySellerStatusEntity 查询失败！");
        }
        return result;
    }

    @Override
    public Map<String, String> queryWithDetail(DataDictionaryTypeEnum dicType, String trustNo) {
        return null;
    }

    @Override
    public R queryData(String type) {
        List<DataDictionarySellerStatusEntity> entities = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(entities)) {
            return R.ok("查询字典信息成功！")
                    .put("data", entities.stream().collect(Collectors.toMap(DataDictionarySellerStatusEntity::getKeyStr
                            ,DataDictionarySellerStatusEntity::getValue)));
        }
        return R.ok("字典信息为空，请联系管理员配置！");
    }
}